--                                                                    --
--  package                         Copyright (c)  Dmitry A. Kazakov  --
--     Test_My_String.Handle                       Luebeck            --
--  Implementation                                 Summer, 2002       --
--                                                                    --
--                                Last revision :  22:08 05 Dec 2004  --
--                                                                    --
--  This  library  is  free software; you can redistribute it and/or  --
--  modify it under the terms of the GNU General Public  License  as  --
--  published by the Free Software Foundation; either version  2  of  --
--  the License, or (at your option) any later version. This library  --
--  is distributed in the hope that it will be useful,  but  WITHOUT  --
--  ANY   WARRANTY;   without   even   the   implied   warranty   of  --
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  --
--  General  Public  License  for  more  details.  You  should  have  --
--  received  a  copy  of  the GNU General Public License along with  --
--  this library; if not, write to  the  Free  Software  Foundation,  --
--  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    --
--                                                                    --
--  As a special exception, if other files instantiate generics from  --
--  this unit, or you link this unit with other files to produce  an  --
--  executable, this unit does not by  itself  cause  the  resulting  --
--  executable to be covered by the GNU General Public License. This  --
--  exception  does not however invalidate any other reasons why the  --
--  executable file might be covered by the GNU Public License.       --
--____________________________________________________________________--

package body Test_My_String.Handle is

   function Create (Value : String) return My_Safe_String is
      Ptr : My_String_Ptr := new My_String (Value'Length);
   begin
      Ptr.Value := Value; 
      return Ref (Ptr);
   end Create;
   
   function Value (Reference : My_Safe_String) return String is
   begin
      return Ptr (Reference).Value;
   end Value;

   procedure Copy
             (  Reference : in out My_Safe_String;
                New_Value : String
             )  is
   begin
      Reference := Create (New_Value);
   end Copy;
   
   procedure Copy
             (  Reference : in out My_Safe_String;
                New_Value : My_Safe_String
             )  is
   begin
      Reference := Create (Value (New_Value));
   end Copy;

   function Ref (Pointer : My_String_Ptr) return My_Safe_String is
   begin
      return (My_String_Handle.Ref (Pointer) with null record);
   end Ref;

end Test_My_String.Handle;
